<?php
function copyr($src, $dst) {
    $src .= ((substr($src, -1) == '/') ? '' : '/');
    $dst .= ((substr($dst, -1) == '/') ? '' : '/');
    
    $bOK = true;
    $dir = opendir($src);
    @mkdir($dst);
    while (($file = readdir($dir)) !== false) {
        if (($file != '.') && ($file != '..')) {
            if (is_dir($src . $file)) {
                mkdir($dst . $file, 0755);
                if (!copyr($src . $file, $dst . $file)) {
                    $bOK = false;
                }
            }
            else {
                if (!copy($src . $file, $dst . $file)) {
                    $bOK = false;
                }
            }
        }
    }
    closedir($dir);
    return $bOK;
}
function designlog($text) {
    global $cfg, $bDebug;

    if ($bDebug) {
        $fp = fopen($cfg['path']['contenido'] . 'data/logs/design-manager.log', 'a');
        fwrite($fp, date('Y-m-d H:i:s') . ' ' . $text . "\n");
        fclose($fp);
    }
}
function deleteTableData($db, $table, $aFilter = array()) {
    
    # Transform the filter array to a query string
    $sFilter = '';
    if (count($aFilter)) {
        $sFilter = ' WHERE (';
        foreach ($aFilter as $key => $value) {
            if (is_array($value)) {
                $sFilter .= '(`' . $key . '` IN ("' . implode('","', $value) . '")) AND ';
            }
            elseif (strtoupper(substr($value, 0, 6)) == 'SELECT') {
                $sFilter .= '(`' . $key . '` IN (' . $value . ')) AND ';
            }
            else {
                $sFilter .= '(`' . $key . '`="' . $value . '") AND ';
            }
        }
        $sFilter = substr($sFilter, 0, -5) . ')';
    }
    
    # Delete the data from this table
    $db->query('DELETE FROM ' . $table . $sFilter);
}
function exportTableData($file, $table, $aFilter = array(), $aReplacements = array(), $bExportStructure = false, $bIncludeTruncate = false) {
    global $cfg, $bDebug;
    
    $iStart = time();
    $iMET = (intval(ini_get('max_execution_time')) - 10); # We need some time for other tasks
    $db = new DB();
    $return = '';
    
    # Open the output file
    if (!$handle = fopen($file, 'a')) {
        return false;
    }

    # Export the table structure if requested
    $sCol = '';
    if ($bExportStructure) {
        # Export the CREATE TABLE command
        $db->query('SHOW CREATE TABLE `' . $table . '`');
        if ($db->next_record()) {
            $sCreate = str_replace(array('CREATE TABLE ', ' COLLATE ' . $cfg['db']['connection']['encoding'], $cfg['sql']['sqlprefix']), array('CREATE TABLE IF NOT EXISTS ', '', '!PREFIX!'), $db->f('Create Table'));
            $p1 = strpos($sCreate, ' ENGINE=');
            if ($p1 !== false) {
                $sCreate = substr($sCreate, 0, $p1);
            }
            if (substr($sCreate, -1) != ';') {
                $sCreate .= ';';
            }
            fwrite($handle, $sCreate . "\n");
            # Remember the first column name as the key column
            $aLines = explode("\n", str_replace(array("\r\n", "\r"), "\n", $sCreate));
            $sLine = trim(str_replace('`', '', $aLines[1]));
            $p1 = strpos($sLine, ' ');
            $sCol = trim(substr($sLine, 0, $p1));
        }
        # Do we need an entry in the sequence table for this table?
        $sql = 'SELECT `seq_name`
                FROM `' . $cfg['tab']['sequence'] . '`
                WHERE (`seq_name`="' . $table . '")';
        $db->query($sql);
        if ($db->next_record()) {
            $sql = 'INSERT INTO `!PREFIX!_sequence` (`seq_name`, `nextid`)' . "\n" .
                    'VALUES ("' . str_replace($cfg['sql']['sqlprefix'], '!PREFIX!', $table) . '", 0)' . "\n" .
                    'ON DUPLICATE KEY UPDATE `nextid`=`nextid`;';
            fwrite($handle, $sql . "\n");
            # Add the first column to the $aReplacements array
            $aReplacements[$sCol] = '!' . strtoupper($sCol) . '_*!';
        }
    }
    if ($bIncludeTruncate) {
        $sql = 'TRUNCATE TABLE `' . str_replace($cfg['sql']['sqlprefix'], '!PREFIX!', $table) . '`;';
        fwrite($handle, $sql . "\n");
    }
    
    # Get the key (first) column in the table (we sort it on this to export
    # each row just once if we split because of the time management)
    $db->query('SHOW COLUMNS FROM ' . $table);
    $db->next_record();
    $row = $db->toArray(DB_SQL_Abstract::FETCH_NUMERIC);
    $key_column = $row[0];
    
    # Transform the filter array to a query string
    $sFilter = '';
    if (count($aFilter)) {
        $sFilter = ' WHERE (';
        foreach ($aFilter as $key => $value) {
            if (is_array($value)) {
                if ($key == 'perms') {
                    $sFilter .= '(';
                    foreach ($value as $val) {
                        $sFilter .= '(`perms` LIKE "%' . $val . '%") OR ';
                    }
                    $sFilter = substr($sFilter, 0, -4) . ') AND ';
                }
                else {
                    $sFilter .= '(`' . $key . '` IN ("' . implode('","', $value) . '")) AND ';
                }
            }
            elseif (strtoupper(substr($value, 0, 6)) == 'SELECT') {
                $sFilter .= '(`' . $key . '` IN (' . $value . ')) AND ';
            }
            else {
                $sFilter .= '(`' . $key . '`="' . $value . '") AND ';
            }
        }
        $sFilter = substr($sFilter, 0, -5) . ')';
        designlog('$sFilter = ' . $sFilter);
    }
    
    # Get the amount of rows in this table
    $db->query('SELECT COUNT(' . $key_column . ') AS num_rows FROM ' . $table . $sFilter);
    $db->next_record();
    $num_rows = $db->f('num_rows');
    
    # Get the columns
    $db->query('SELECT * FROM ' . $table . $sFilter . ' ORDER BY ' . $key_column . ' LIMIT 0, 1');
    if ($db->next_record()) {
        $row = $db->toArray(DB_SQL_Abstract::FETCH_BOTH);
        $return .= 'INSERT INTO `' . str_replace($cfg['sql']['sqlprefix'], '!PREFIX!', $table) . '` (`';
        $keys = array();
        foreach ($row as $key => $value) {
            if (!is_numeric($key)) {
                $keys[] = $key;
            }
        }
        $return .= implode('`, `', $keys);
        $return .= '`) VALUES' . "\n";
    }
    
    # Query the data
    $current_row = 0;
    $db->query('SELECT * FROM ' . $table . $sFilter . ' ORDER BY ' . $key_column . ' LIMIT ' . $current_row . ', ' . ($num_rows - $current_row));
    $num_fields = $db->num_fields();
    $aRows = array();
    while ($db->next_record()) {
        $aRows[] = $db->toArray(DB_SQL_Abstract::FETCH_BOTH);
    }
    foreach ($aRows as $row) {
        $return .= '(';
        for ($i = 0; $i < $num_fields; $i++) {
            $bOK = false;
            foreach ($aReplacements as $key => $value) {
                if ($key == $keys[$i]) {
                    if (($table == $cfg['tab']['properties']) && ($value == '!ID_*!')) {
                        switch ($row[($i - 1)]) {
                            case 'idclient':
                            case 'clientsetting':
                                $return .= "'!IDCLIENT!'";
                                break;
                            default:
                                $return .= "'!" . strtoupper($row[($i - 1)]) . "_" . $row[$i] . "!'";
                                break;
                        }
                    }
                    elseif ($value == 'NULL') {
                        $return .= 'NULL';
                    }
                    elseif (is_array($value)) {
                        if ($table == $cfg['tab']['content']) {
                            $bOK = false;
                            if ($keys[$i] == 'value') {
                                foreach ($value as $search => $replace) {
                                    # Format: $search = '4', $replace = '!IDUPL_*!'
                                    if (($row['idtype'] == (int)$search) && (is_numeric($row[$i]))) {
                                        $ret = "'" . str_replace('*', $row[$i], $replace) . "'";
                                        $bOK = true;
                                        break;
                                    }
                                }
                            }
                            if (!$bOK) {
                                $ret = "'" . $row[$i] . "'";
                            }
                        }
                        elseif ($table == $cfg['tab']['container_conf']) {
                            if ($keys[$i] == 'container') {
                                $ret = "'" . $row[$i] . "'";
                                foreach ($value as $search => $replace) {
                                    foreach ($replace as $find => $make) {
                                        if (in_array($row['number'], explode(',', $find))) {
                                            foreach ($make as $makeSearch => $makeReplace) {
                                                if (strpos($makeSearch, '*') !== false) {
                                                    $sRegEx = '/' . str_replace(array('*', '&'), array('(.*)', '\\&'), $makeSearch) . '/U';
                                                    $aMatches = array();
                                                    if (preg_match_all($sRegEx, $row[$i], $aMatches, PREG_SET_ORDER)) {
                                                        foreach ($aMatches as $aMatch) {
                                                            $makeReplace = str_replace('*', '%s', $makeReplace);
                                                            $ret = "'" . sprintf($makeReplace, $aMatch[1], $aMatch[2]) . "'";
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else {
                            $ret = "'" . $row[$i] . "'";
                            foreach ($value as $search => $replace) {
                                if (strpos($search, '*') !== false) {
                                    $sRegEx = '/' . str_replace('*', '(.*)', $search) . '/U';
                                    $aMatches = array();
                                    if (preg_match_all($sRegEx, $ret, $aMatches, PREG_SET_ORDER)) {
                                        foreach ($aMatches as $aMatch) {
                                            $ret = str_replace($aMatch[0], str_replace('*', $aMatch[1], $replace), $ret);
                                        }
                                    }
                                }
                                else {
                                    $ret = str_replace($search, $replace, $ret);
                                }
                            }
                        }
                        $return .= $ret;
                    }
                    else {
                        $return .= "'" . str_replace(array("'", '\\', "\r", "\n", '*'), array("''", '\\\\', "\\r", "\\n", $row[$i]), $value) . "'";
                    }
                    $bOK = true;
                }
            }
            if (!$bOK) {
                if ((!isset($row[$i])) || ($row[$i] == 'NULL')) {
                    $return .= 'NULL';
                } elseif (is_numeric($row[$i])) {
                    $return .= $row[$i];
                } else {
                    $return .= "'" . str_replace(array("'", '\\', "\r", "\n"), array("''", '\\\\', "\\r", "\\n"), $row[$i]) . "'";
                }
            }
            if ($i < ($num_fields - 1)) {
                $return .= ', ';
            }
        }
        $return .= ')';
        $current_row ++;
        
        # Time management
        if ((time() - $iStart) >= $iMET) {
            $return .= ';' . "\n";
            fwrite($handle, $return);
            return array('table' => $table, 'row' => $current_row);
        }
        
        # Query string length management
        elseif (strlen($return) > 30000) {
            $return .= ';' . "\n";
            fwrite($handle, $return);
            $return = 'INSERT INTO `' . str_replace($cfg['sql']['sqlprefix'], '!PREFIX!', $table) . '` (';
            $return .= implode(', ', $keys);
            $return .= ') VALUES' . "\n";
        }
        else {
            $return .= ',' . "\n";
        }
    }
    $return = (((strlen($return) > 1) && (substr($return, -2) == ',' . "\n")) ? substr($return, 0, -2) . ';' . "\n" : '');
    fwrite($handle, $return);
    fclose($handle);
    return true;
}
function in_array_wildcards(string $needle, array $haystack, bool $case_insensitive = true):bool {
    foreach ($haystack as $value) {
        if (strpos($value, '*') !== false) {
            if ((bool)preg_match('/' . str_replace('*', '(.*)', $value) . '/' . (($case_insensitive) ? 'i' : ''), $needle)) {
                return true;
            }
        }
        else {
            if ($case_insensitive) {
                if (strtolower($value) == strtolower($needle)) {
                    return true;
                }
            }
            else {
                if ($value == $needle) {
                    return true;
                }
            }
        }
    }
    return false;
}
?>