<?php
function isWritablePath($sPath) {
    $sPath .= ((substr($sPath, -1) == DIRECTORY_SEPARATOR) ? '' : DIRECTORY_SEPARATOR);
    $sFile = 'sit_' . uniqid(mt_rand()) . '.writable';
    $bOK = false;
    $fp = @fopen($sPath . $sFile, 'w');
    if ($fp !== false) {
        $bOK = true;
        fclose($fp);
        unlink($sPath . $sFile);
    }
    return $bOK;
}
function copyr($src, $dst) {
    $src .= ((substr($src, -1) == '/') ? '' : '/');
    $dst .= ((substr($dst, -1) == '/') ? '' : '/');
    
    $dir = opendir($src);
    @mkdir($dst, 0775, true);
    while (($file = readdir($dir)) !== false) {
        if (($file != '.') && ($file != '..')) {
            if (is_dir($src . '/' . $file)) {
                copyr($src . $file, $dst . $file);
            }
            else {
                copy($src . $file, $dst . $file);
            }
        }
    }
    closedir($dir);
}
function installModule($sModule, $bUpdate) {
    global $db, $cfg, $cfgClient, $client;
    
    $oModule = new ModuleInfo($sModule);
    $aInstall = $oModule->getInstallInfo();
    $aInfo = $oModule->getInfo();
    if ($aInstall !== false) {
        if ($bUpdate) {
            
            # Update the module instances for the client (can be more than one)
            $sql = 'SELECT `idmod`, `name`, `modified`
                    FROM `' . $cfg['tab']['mod'] . '`
                    WHERE (`orig_name`="' . Contenido_Security::escapeDB($aInfo['Name'], $db) . '")
                    ORDER BY `name`';
            $db->query($sql);
            if ($db->num_rows()) {
                while ($db->next_record()) {
                    if ($db->f('modified')) {
                        echo '<p>' . sprintf(i18n("Module %s not updated, it was changed"), $db->f('name')) . '</p>';
                        flush();
                    }
                    else {
                        $oAM = new cApiModule($db->f('idmod'));
                        $oAM->import($cfgClient[$client]['path']['frontend'] . 'data/modules_c/' . $sModule . '/' . $aInstall['module']);
                        echo '<p>' . sprintf(i18n("Module %s updated"), $aInfo['Name']) . '</p>';
                        flush();

                        # Install the translations for the client
                        installModuleTranslations($aInstall, $oAM, $sModule);
                    }
                }
            }
            else {
                $bUpdate = false;
            }
        }
        if (!$bUpdate) {
            
            # Install the module for the client
            $oAMC = new cApiModuleCollection();
            $oAM = $oAMC->create($aInfo['Name']);
            $oAM->import($cfgClient[$client]['path']['frontend'] . 'data/modules_c/' . $sModule . '/' . $aInstall['module']);
            echo '<p>' . sprintf(i18n("Module %s installed"), $aInfo['Name']) . '</p>';
            flush();

            # Install the translations for the client
            installModuleTranslations($aInstall, $oAM, $sModule);
        }
        
        return true;
    }
    else {
        return false;
    }
}
function installModuleTranslations($aInstall, $oAM, $sModule) {
    global $cfgClient, $client;

    if (count($aInstall['languages'])) {
        $aLangs = array();
        $oCLC = new cApiClientLanguageCollection();
        $oCLC->setWhere('idclient', $client);
        $oCLC->query();
        
        while ($oItem = $oCLC->next()) {
            $oLang = new cApiLanguage($oItem->get("idlang"));
            $aLangs[$oItem->get("idlang")] = array('name' => $oLang->get('name'), 'code' => $oLang->getProperty('language', 'code') . '_' . strtoupper($oLang->getProperty('country', 'code')));
        }
        unset($oCLC, $oItem, $oLang);
        
        $oTranslations = new cApiModuleTranslationCollection();
        foreach ($aInstall['languages'] as $sLangCode => $sLangFile) {
            
            # Install the translations only if this language is present
            foreach ($aLangs as $idlang => $aLang) {
                if ($aLang['code'] == $sLangCode) {
                    $oTranslations->import($oAM->get('idmod'), $idlang, $cfgClient[$client]['path']['frontend'] . 'data/modules_c/' . $sModule . '/' . $sLangFile);
                    echo '<p>' . sprintf(i18n("Module translations installed for language %s"), $aLang['name']) . '</p>';
                    flush();
                }
            }
        }
        unset($oTranslations);
    }
}
function addDirSep($sPath) {
    return $sPath . ((substr($sPath, -1) == '/') ? '' : '/');
}
?>