<?php
function isWritablePath($sPath) {
    $sPath .= ((substr($sPath, -1) == DIRECTORY_SEPARATOR) ? '' : DIRECTORY_SEPARATOR);
    $sFile = 'sit_' . uniqid(mt_rand()) . '.writable';
    $bOK = false;
    $fp = @fopen($sPath . $sFile, 'w');
    if ($fp !== false) {
        $bOK = true;
        fclose($fp);
        unlink($sPath . $sFile);
    }
    return $bOK;
}
function copyr($src, $dst) {
    $src .= ((substr($src, -1) == '/') ? '' : '/');
    $dst .= ((substr($dst, -1) == '/') ? '' : '/');
    
    $dir = opendir($src);
    @mkdir($dst);
    while (($file = readdir($dir)) !== false) {
        if (($file != '.') && ($file != '..')) {
            if (is_dir($src . '/' . $file)) {
                copyr($src . $file, $dst . $file);
            }
            else {
                copy($src . $file, $dst . $file);
            }
        }
    }
    closedir($dir);
}
function installPlugin($sPlugin, $sPluginName, $bUpdate) {
    global $oPlugin, $aDescription, $db, $cfg;

    # First get the 
    
    $aInstall = $oPlugin->getInstallInfo();
    if ($aInstall !== false) {
        echo '<p>' . i18n("Installing database entries") . '</p>';
        flush();
        $aDescription = array();
        
        # Areas
        for ($i = 0, $n = count($aInstall['areas']); $i < $n; $i ++) {
            $id = $db->nextid($cfg['tab']['area']);
            if ((is_numeric($aInstall['areas'][$i]['parent'])) && ($aInstall['areas'][$i]['parent'] != 0)) {
                $sql = 'INSERT INTO ' . $cfg['tab']['area'] . ' (idarea, parent_id, name, relevant, online, menuless)
                        VALUES (' . $id . ', "' . Contenido_Security::escapeDB((string) $aInstall['areas'][($aInstall['areas'][$i]['parent'] - 1)]['name'], $db) . '", "' . Contenido_Security::escapeDB((string) $aInstall['areas'][$i]['name'], $db) . '", ' . intval($aInstall['areas'][$i]['relevant']) . ', ' . intval($aInstall['areas'][$i]['online']) . ', ' . intval($aInstall['areas'][$i]['menuless']) . ')';
            }
            else {
                $sql = 'INSERT INTO ' . $cfg['tab']['area'] . ' (idarea, parent_id, name, relevant, online, menuless)
                        VALUES (' . $id . ', "' . Contenido_Security::escapeDB((string) $aInstall['areas'][$i]['parent'], $db) . '", "' . Contenido_Security::escapeDB((string) $aInstall['areas'][$i]['name'], $db) . '", ' . intval($aInstall['areas'][$i]['relevant']) . ', ' . intval($aInstall['areas'][$i]['online']) . ', ' . intval($aInstall['areas'][$i]['menuless']) . ')';
            }
            $db->query($sql);
            $aInstall['areas'][$i]['idarea'] = $id;
            $aDescription[] = array('table' => $cfg['tab']['area'], 'id' => $id);
        }
        
        # Actions
        for ($i = 0, $n = count($aInstall['actions']); $i < $n; $i ++) {
            $id = $db->nextid($cfg['tab']['actions']);
            $sCode = (string) $aInstall['actions'][$i]['code'];
            if ($sCode == 'Array') {
                $sCode = '';
            }
            $sLocation = (string) $aInstall['actions'][$i]['location'];
            if ($sLocation == 'Array') {
                $sLocation = '';
            }
            $sql = 'INSERT INTO ' . $cfg['tab']['actions'] . ' (idaction, idarea, alt_name, name, code, location, relevant)
                    VALUES (' . $id . ', ' . intval($aInstall['areas'][(intval($aInstall['actions'][$i]['area']) - 1)]['idarea']) . ', "' . Contenido_Security::escapeDB((string) $aInstall['actions'][$i]['alt_name'], $db) . '", "' . Contenido_Security::escapeDB((string) $aInstall['actions'][$i]['name'], $db) . '", "' . Contenido_Security::escapeDB($sCode, $db) . '", "' . Contenido_Security::escapeDB($sLocation, $db) . '", "' . Contenido_Security::escapeDB((string) $aInstall['actions'][$i]['relevant'], $db) . '")';
            $db->query($sql);
            $aInstall['actions'][$i]['idaction'] = $id;
            $aDescription[] = array('table' => $cfg['tab']['actions'], 'id' => $id);
        }
        
        # Files
        for ($i = 0, $n = count($aInstall['files']); $i < $n; $i ++) {
            $id = $db->nextid($cfg['tab']['files']);
            if (is_numeric($aInstall['files'][$i]['area'])) {
                $sql = 'INSERT INTO ' . $cfg['tab']['files'] . ' (idfile, idarea, filename, filetype)
                        VALUES (' . $id . ', ' . intval($aInstall['areas'][(intval($aInstall['files'][$i]['area']) - 1)]['idarea']) . ', "' . Contenido_Security::escapeDB((string) $aInstall['files'][$i]['filename'], $db) . '", "' . Contenido_Security::escapeDB((string) $aInstall['files'][$i]['filetype'], $db) . '")';
            }
            else {
                $sql = 'SELECT idarea
                        FROM ' . $cfg['tab']['area'] . '
                        WHERE (name="' . $aInstall['files'][$i]['area'] . '")';
                $db->query($sql);
                if ($db->next_record()) {
                    $idarea = $db->f('idarea');
                }
                $sql = 'INSERT INTO ' . $cfg['tab']['files'] . ' (idfile, idarea, filename, filetype)
                        VALUES (' . $id . ', ' . intval($idarea) . ', "' . Contenido_Security::escapeDB((string) $aInstall['files'][$i]['filename'], $db) . '", "' . Contenido_Security::escapeDB((string) $aInstall['files'][$i]['filetype'], $db) . '")';
            }
            $db->query($sql);
            $aInstall['files'][$i]['idfile'] = $id;
            $aDescription[] = array('table' => $cfg['tab']['files'], 'id' => $id);
        }
        
        # FrameFiles
        for ($i = 0, $n = count($aInstall['frame_files']); $i < $n; $i ++) {
            $id = $db->nextid($cfg['tab']['framefiles']);
            if (is_numeric($aInstall['frame_files'][$i]['area'])) {
                $sql = 'INSERT INTO ' . $cfg['tab']['framefiles'] . ' (idframefile, idarea, idframe, idfile)
                        VALUES (' . $id . ', ' . intval($aInstall['areas'][(intval($aInstall['frame_files'][$i]['area']) - 1)]['idarea']) . ', ' . intval($aInstall['frame_files'][$i]['frame_id']) . ', ' . intval($aInstall['files'][(intval($aInstall['frame_files'][$i]['file']) - 1)]['idfile']) . ')';
            }
            else {
                $sql = 'SELECT idarea
                        FROM ' . $cfg['tab']['area'] . '
                        WHERE (name="' . $aInstall['frame_files'][$i]['area'] . '")';
                $db->query($sql);
                if ($db->next_record()) {
                    $idarea = $db->f('idarea');
                }
                $sql = 'INSERT INTO ' . $cfg['tab']['framefiles'] . ' (idframefile, idarea, idframe, idfile)
                        VALUES (' . $id . ', ' . intval($idarea) . ', ' . intval($aInstall['frame_files'][$i]['frame_id']) . ', ' . intval($aInstall['files'][(intval($aInstall['frame_files'][$i]['file']) - 1)]['idfile']) . ')';
            }
            $db->query($sql);
            $aInstall['frame_files'][$i]['idframefile'] = $id;
            $aDescription[] = array('table' => $cfg['tab']['framefiles'], 'id' => $id);
        }
        
        # NavMain
        for ($i = 0, $n = count($aInstall['nav_main']); $i < $n; $i ++) {
            $id = $db->nextid($cfg['tab']['nav_main']);
            $sql = 'INSERT INTO ' . $cfg['tab']['nav_main'] . ' (idnavm, location)
                    VALUES (' . $id . ', "' . Contenido_Security::escapeDB((string) $aInstall['nav_main'][$i]['location'], $db) . '")';
            $db->query($sql);
            $aInstall['nav_main'][$i]['idnavm'] = $id;
            $aDescription[] = array('table' => $cfg['tab']['nav_main'], 'id' => $id);
        }
        
        # NavSub
        for ($i = 0, $n = count($aInstall['nav_subs']); $i < $n; $i ++) {
            $id = $db->nextid($cfg['tab']['nav_sub']);
            if (is_numeric($aInstall['nav_subs'][$i]['nav_main'])) {
                if (strlen($aInstall['nav_main'][$aInstall['nav_subs'][$i]['nav_main']]['idnavm'])) {
                    $idnavm = intval($aInstall['nav_main'][$aInstall['nav_subs'][$i]['nav_main']]['idnavm']);
                }
                else {
                    $idnavm = (int) $aInstall['nav_subs'][$i]['nav_main'];
                }
            }
            else {
                $sql = 'SELECT idnavm
                        FROM ' . $cfg['tab']['nav_main'] . '
                        WHERE (location LIKE "%' . Contenido_Security::escapeDB((string) $aInstall['nav_subs'][$i]['nav_main'], $db) . '%")';
                $db->query($sql);
                $db->next_record();
                $idnavm = $db->f('idnavm');
            }
            $sql = 'INSERT INTO ' . $cfg['tab']['nav_sub'] . ' (idnavs, idnavm, idarea, level, location, online)
                    VALUES (' . $id . ', ' . $idnavm . ', ' . intval($aInstall['areas'][(intval($aInstall['nav_subs'][$i]['area']) - 1)]['idarea']) . ', ' . intval($aInstall['nav_subs'][$i]['level']) . ', "' . Contenido_Security::escapeDB((string) $aInstall['nav_subs'][$i]['location'], $db) . '", ' . intval($aInstall['nav_subs'][$i]['online']) . ')';
            $db->query($sql);
            $aInstall['nav_subs'][$i]['idframefile'] = $id;
            $aDescription[] = array('table' => $cfg['tab']['nav_sub'], 'id' => $id);
        }
        
        if ($bUpdate) {
            $idplugin = 0;
            
            # Check if there is install info and get it
            $sql = 'SELECT `idplugin`, `description`
                    FROM `' . $cfg['tab']['plugins'] . '`
                    WHERE ((`name`="' . $sPluginName . '")
                       AND (`path`="' . $sPlugin . '"))';
            $db->query($sql);
            if ($db->next_record()) { # old plugins don't have a `path` saved
                $idplugin = $db->f('idplugin');
                $aDescription = json_decode($db->f('description'), true);
                
                # Delete the database entries
                foreach ($aDescription as $value) {
                    $sql = 'SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE (table_name="' . $value['table'] . '")';
                    $db->query($sql);
                    if ($db->next_record()) {
                        $sql = 'DELETE FROM ' . $value['table'] . ' WHERE (' . $db->f(0) .'=' . $value['id'] . ')';
                        $db->query($sql);
                    }
                }
            }
            else {

                # Old style plugin, get the infos from the database
                $sql = 'SELECT *
                        FROM `' . $cfg['tab']['plugins'] . '`
                        WHERE (`name`="' . $sPlugin . '")';
                $db->query($sql);
                if ($db->next_record()) {
                    $idplugin = $db->f('idplugin');
                    $aCommands = array();
                    if (null != $db->f('uninstall')) {
                        # Parse the 'uninstall' field
                        $aCommands = explode(';', str_replace(array("\r\n", "\r"), "\n", $db->f('uninstall')));
                    }
                    elseif (file_exists($cfg['path']['contenido'] . $cfg['path']['plugins'] . $sPlugin . '/uninstall.sql')) {
                        # Parse the 'uninstall.sql' in the plugin folder
                        $aCommands = explode(';', str_replace(array("\r\n", "\r"), "\n", file_get_contents($cfg['path']['contenido'] . $cfg['path']['plugins'] . $sPlugin . '/uninstall.sql')));
                    }
                    
                    # Delete the database entries
                    foreach ($aCommands as $sCommand) {
                        $sCommand = trim($sCommand);
                        if (substr($sCommand, 0, 11) == 'DELETE FROM') {
                            $db->query($sCommand);
                        }
                    }
                }
            }
            if ($idplugin) {
                # Delete the record from the _plugins table
                $sql = 'DELETE FROM ' . $cfg['tab']['plugins'] . '
                        WHERE (idplugin=' . $idplugin . ')';
                $db->query($sql);
            }
        }
        
        # Enter plugin into _plugins
        echo '<p>' . sprintf(i18n("Registering plugin %s in database"), $sPluginName) . '</p>';
        flush();
        $id = $db->nextid($cfg['tab']['plugins']);
        $sql = 'INSERT INTO ' . $cfg['tab']['plugins'] . ' (idplugin, name, description, path, installed)
                VALUES (' . $id . ', "' . $sPluginName . '", "' . Contenido_Security::escapeDB((string) json_encode($aDescription), $db) . '", "' . $sPlugin . '", 1)';
        $db->query($sql);
        
        return true;
    }
    else {
        return false;
    }
}
function installModule($sPlugin, $sModule) {
    global $db, $cfg;
    
    $oModule = new ModuleInfo($sPlugin, $sModule);
    $aInstall = $oModule->getInstallInfo();
    $aInfo = $oModule->getInfo();
    if ($aInstall !== false) {
        
        # Update the module instances for the client (can be more than one)
        $sql = 'SELECT `idmod`, `name`, `modified`
                FROM `' . $cfg['tab']['mod'] . '`
                WHERE (`orig_name`="' . Contenido_Security::escapeDB($aInfo['Name'], $db) . '")
                ORDER BY `name`';
        $db->query($sql);
        if ($db->num_rows()) {
            while ($db->next_record()) {
                if ($db->f('modified')) {
                    echo '<p>' . sprintf(i18n("Module %s not updated, it was changed"), $db->f('name')) . '</p>';
                    flush();
                }
                else {
                    $oAM = new cApiModule($db->f('idmod'));
                    $oAM->import($cfg['path']['contenido'] . 'plugins/' . $sPlugin . '/modules/' . $sModule . '/' . $aInstall['module']);
                    echo '<p>' . sprintf(i18n("Module %s updated"), $aInfo['Name']) . '</p>';
                    flush();

                    # Install the translations for the client
                    installModuleTranslations($aInstall, $oAM, $sModule);
                }
            }
        }
        else {
            
            # Install the module for the client
            $oAMC = new cApiModuleCollection();
            $oAM = $oAMC->create($aInfo['Name']);
            $oAM->import($cfg['path']['contenido'] . 'plugins/' . $sPlugin . '/modules/' . $sModule . '/' . $aInstall['module']);
            echo '<p>' . sprintf(i18n("Module %s installed"), $aInfo['Name']) . '</p>';
            flush();

            # Install the translations for the client
            installModuleTranslations($aInstall, $oAM, $sPlugin, $sModule);
        }
        
        return true;
    }
    else {
        return false;
    }
}
function installModuleTranslations($aInstall, $oAM, $sPlugin, $sModule) {
    global $cfg, $client;

    if (count($aInstall['languages'])) {
        $aLangs = array();
        $oCLC = new cApiClientLanguageCollection();
        $oCLC->setWhere('idclient', $client);
        $oCLC->query();
        
        while ($oItem = $oCLC->next()) {
            $oLang = new cApiLanguage($oItem->get("idlang"));
            $aLangs[$oItem->get("idlang")] = array('name' => $oLang->get('name'), 'code' => $oLang->getProperty('language', 'code') . '_' . strtoupper($oLang->getProperty('country', 'code')));
        }
        unset($oCLC, $oItem, $oLang);
        
        $oTranslations = new cApiModuleTranslationCollection();
        foreach ($aInstall['languages'] as $sLangCode => $sLangFile) {
            
            # Install the translations only if this language is present
            foreach ($aLangs as $idlang => $aLang) {
                if ($aLang['code'] == $sLangCode) {
                    $oTranslations->import($oAM->get('idmod'), $idlang, $cfg['path']['contenido'] . 'plugins/' . $sPlugin . '/modules/' . $sModule . '/' . $sLangFile);
                    echo '<p>' . sprintf(i18n("Module translations installed for module %s for language %s"), $sModule, $aLang['name']) . '</p>';
                    flush();
                }
            }
        }
        unset($oTranslations);
    }
}
function addDirSep($sPath) {
    return $sPath . ((substr($sPath, -1) == '/') ? '' : '/');
}
?>